-
Notifications
You must be signed in to change notification settings - Fork 0
/
gear-rack.kcl
60 lines (54 loc) · 2.01 KB
/
gear-rack.kcl
1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32
33
34
35
36
37
38
39
40
41
42
43
44
45
46
47
48
49
50
51
52
53
54
55
56
57
58
59
60
// 100mm Gear Rack
// A flat bar or rail that is engraved with teeth along its length. These teeth are designed to mesh with the teeth of a gear, known as a pinion. When the pinion, a small cylindrical gear, rotates, its teeth engage with the teeth on the rack, causing the rack to move linearly. Conversely, linear motion applied to the rack will cause the pinion to rotate.
// Define constants
length = 100
pitchHeight = 11.5
width = 5
height = 12
minHeight = 10.875
// Create the body of the rack
rackBody = startSketchOn('XY')
|> startProfileAt([-length / 2, 0], %)
|> line([length, 0], %)
|> line([0, minHeight], %)
|> line([-length, 0], %)
|> close(%)
|> extrude(width, %)
// Create a function for sketch of a single tooth
fn tooth = () => {
toothSketch = startSketchOn('XY')
|> startProfileAt([-length / 2 + 0.567672, minHeight], %)
|> tangentialArcToRelative([0.157636, 0.110378], %)
|> line([0.329118, 0.904244], %)
|> tangentialArcToRelative([0.157636, 0.110378], %)
|> line([0.186505, 0], %)
|> tangentialArcToRelative([0.157636, -0.110378], %)
|> line([0.329118, -0.904244], %)
|> tangentialArcToRelative([0.157636, -0.110378], %)
|> close(%)
|> extrude(width, %)
return toothSketch
}
// Pattern the single tooth over the length of the rack body
teeth = tooth()
|> patternLinear3d({
axis: [10, 0, 0],
distance: 1.570796,
instances: 63
}, %)
// Sketch and extrude the first end cap. This is a partial tooth
endCapTooth = startSketchOn('XY')
|> startProfileAt([-length / 2, 11.849525], %)
|> line([0.314524, -0.864147], %)
|> tangentialArcToRelative([0.157636, -0.110378], %)
|> lineTo([-length / 2, minHeight], %)
|> close(%)
|> extrude(width, %)
//Sketch and extrude the second end cap. This is a partial tooth
endCapTooth2 = startSketchOn('XY')
|> startProfileAt([length / 2, 11.849525], %)
|> line([-0.314524, -0.864147], %)
|> tangentialArcToRelative([-0.157636, -0.110378], %)
|> lineTo([length / 2, minHeight], %)
|> close(%)
|> extrude(width, %)